Pull request: https://github.com/theforeman/foreman/p

ull/2684

  

Description

I believe there is a N+1 query when modifying a single host or multiple hosts from the "All Hosts" page of the Foreman. Changing a

hostgroup from this page is taking ~5-8 minutes to complete depending on the number of hosts being modified.

Found by loading foreman-rake console

hg = Hostgroup.find_by_id(1)

h = Host.find_by_name("name of host")

h.hostgroup=hg

h.save(:validate => false)

I've attached the specific query that I believe has the N+1. It is executed several times in this block of code which I think is the reason

the host group change takes such a long time to complete.

Related issues:

Related to Foreman - Tracker #11657: Performance refactoring for HostsController New 09/02/2015

Associated revisions

Revision 88275be4 - 09/09/2015 09:45 AM - Tom Caspy

fixes #10589 - removing N+1 queries from after_save callbacks when changing hostgroup

Revision 37331501 - 09/22/2015 07:06 AM - Tom Caspy

fixes #10589 - removing N+1 queries from after_save callbacks when changing hostgroup

(cherry picked from commit 88275be4587e98092095c501a8a7f58d7bcfaca4)

History

#1 - 05/22/2015 10:20 AM - Dominic Cleal

- Category set to Performance

#2 - 08/26/2015 11:27 AM - Bryan Kearney

- Bugzilla link set to 1257268

#3 - 08/31/2015 01:41 AM - Ohad Levy

- Assignee set to Tom Caspy

#4 - 09/03/2015 05:09 AM - Tom Caspy

- Related to Tracker #11657: Performance refactoring for HostsController added

#5 - 09/08/2015 07:04 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2684 added
- Pull request deleted ()

#6 - 09/09/2015 09:45 AM - Dominic Cleal

- translation missing: en.field_release set to 72

#7 - 09/09/2015 10:02 AM - Tom Caspy

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 88275be4587e98092095c501a8a7f58d7bcfaca4.

#8 - 09/11/2015 05:29 AM - Dominic Cleal

- translation missing: en.field_release changed from 72 to 88
